"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
class ModuleInvoker {
    static invokeHandler(handler, jsonRequest) {
        const handlerParts = handler.split(".");
        const functionName = handlerParts[handlerParts.length - 1];
        const fileName = handlerParts.slice(0, handlerParts.length - 1).join("/") + ".js";
        const fullPath = path.join(process.cwd(), fileName);
        const handlerModule = require(fullPath);
        return ModuleInvoker.invokeFunction(handlerModule[functionName], jsonRequest);
    }
    static invokeFunction(googleFunction, jsonRequest) {
        return new Promise((resolve, reject) => {
            const response = {
                status: (code) => {
                    return response;
                },
                send: (payload) => {
                    resolve(payload);
                    return response;
                }
            };
            try {
                googleFunction(jsonRequest, response);
            }
            catch (error) {
                reject(error);
            }
        });
    }
}
exports.ModuleInvoker = ModuleInvoker;
//# sourceMappingURL=ModuleInvoker.js.map